var path = require('path');


var vm = require('vm');

function define(argA) {
  var type;
  switch (argA.constructor) {
    case Array:
      type = 'array';
      break;
    case String:
      type = 'string';
      break;
    case Function:
      type = 'function';
      break;
    case Object:
      type = 'object';
      break;
  }
  return type;
}
/*
var outputA = 'define("id", function (require, exports, module) {});';
var inputA = 'define("alpha", ["require", "exports", "module"], function (require, exports, module) {});';
var inputB = 'define(["alpha"], function (alpha) {});';
var inputC = 'define({"alpha": function () {}});';
var inputD = 'define(function (require, exports, module) {});';
var inputE = 'module.exports = function (alpha) {return alpha}';
var result = vm.runInNewContext(define.toString() + ';try{' + inputE + '}catch(err){"undefined"}');
console.log(result);
//*/

module.exports = function(grunt) {
  grunt.registerMultiTask('weibo-define', 'Wrap .js files', function() {
    this.files.forEach(function(file) {
      return file.src.map(function(filepath) {
        var definePath = (filepath.replace(/\.\w+$/, ''));
        var original = grunt.file.read(path.join(file.cwd, filepath));
        var result = vm.runInNewContext(define.toString() + ';\ntry{' + original + '\n}catch(e){}');
        if (result === undefined) {
          return grunt.file.write(file.dest + filepath, '/* PATH: ' + path.join(file.cwd, filepath) + ' */\ndefine("' + definePath + '", function(require, exports, module) {\n' + original + '\n});\n');
        } else {
          throw Error('文件"' + filepath + '"格式不正确/n' + result);
        }
      });
    });
  });
};